use crate::renderer::breadcrumb_tree::BreadcrumbTree;
use crate::renderer::breadcrumb_tree::BreadcrumbTreeNode;
use crate::renderer::context_element::IntoContextElement;
use crate::renderer::WalkError;
use std::borrow::Borrow;

enum WalkResult<'a> {
    NoWalk,
    PartialWalk,
    FullyWalked(&'a dyn IntoContextElement),
}

fn walk_path_from_single_level<'a, P, C>(context: &'a C, path: &[P]) -> WalkResult<'a>
where
    P: Borrow<str>,
    C: Borrow<dyn IntoContextElement + 'a>,
{
    todo!()
}

pub fn walk_path<'a, B, P>(
    maybe_breadcrumbs: Option<&'a BreadcrumbTreeNode<B>>,
    path: &Vec<P>,
) -> Result<&'a dyn IntoContextElement, WalkError>
where
    B: IntoContextElement,
    P: Borrow<str>,
{
    match (maybe_breadcrumbs, path.first()) {
        (None, _) => return Err(WalkError::CantWalk),
        (Some(breadcrumbs), None) => return Ok(breadcrumbs.get_ice()),
        (Some(breadcrumbs), Some(path_first)) if path_first.borrow() == "." => (),
        (Some(breadcrumbs), Some(path_first)) => (),
    }

    Err(WalkError::CantWalk)
}
